#pragma once

#include "CoreMinimal.h"
#include "DepositVoidEnergyInteraction.h"
#include "DBDTunableRowHandle.h"
#include "VoidStationEnergyInteraction.generated.h"

class UChargeableComponent;
class ADBDPlayer;

UCLASS(Blueprintable, EditInlineNew, meta=(BlueprintSpawnableComponent))
class UVoidStationEnergyInteraction : public UDepositVoidEnergyInteraction
{
	GENERATED_BODY()

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, ReplicatedUsing=OnRep_SpawnedChargeable, Export, meta=(AllowPrivateAccess=true))
	UChargeableComponent* _spawnedChargeable;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	FDBDTunableRowHandle _voidEnergyNeeded;

	UPROPERTY(EditAnywhere, Replicated, Transient)
	TWeakObjectPtr<ADBDPlayer> _correspondingPlayer;

private:
	UFUNCTION(BlueprintCallable)
	void OnRep_SpawnedChargeable();

public:
	virtual void GetLifetimeReplicatedProps(TArray<FLifetimeProperty>& OutLifetimeProps) const override;

public:
	UVoidStationEnergyInteraction();
};

FORCEINLINE uint32 GetTypeHash(const UVoidStationEnergyInteraction) { return 0; }
